<template>
  <div>
    <gz-report-selector ref="reportSelector"></gz-report-selector>
    <div v-if="formState.ready">
      <gz-error :error-box-message="formState.errorBoxMessage"></gz-error>
      <v-form ref="form">
        <v-row dense>
          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-text-field
              ref="name"
              v-model="obj.name"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitName')"
              :rules="[form().required(this, 'name')]"
              :error-messages="form().serverErrors(this, 'name')"
              data-cy="name"
              @input="fieldValueChanged('name')"
            ></v-text-field>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'Serial')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-text-field
              ref="serial"
              v-model="obj.serial"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitSerial')"
              data-cy="serial"
              :error-messages="form().serverErrors(this, 'serial')"
              @input="fieldValueChanged('serial')"
            ></v-text-field>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateHourCost')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateHourCost"
              v-model="obj.rateHourCost"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateHourCost')"
              data-cy="rateHourCost"
              :rules="[
                form().decimalValid(this, 'rateHourCost'),
                form().required(this, 'rateHourCost')
              ]"
              :error-messages="form().serverErrors(this, 'rateHourCost')"
              @input="fieldValueChanged('rateHourCost')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateHour')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateHour"
              v-model="obj.rateHour"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateHour')"
              data-cy="rateHour"
              :rules="[
                form().decimalValid(this, 'rateHour'),
                form().required(this, 'rateHour')
              ]"
              :error-messages="form().serverErrors(this, 'rateHour')"
              @input="fieldValueChanged('rateHour')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateHalfDayCost')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateHalfDayCost"
              v-model="obj.rateHalfDayCost"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateHalfDayCost')"
              data-cy="rateHalfDayCost"
              :rules="[
                form().decimalValid(this, 'rateHalfDayCost'),
                form().required(this, 'rateHalfDayCost')
              ]"
              :error-messages="form().serverErrors(this, 'rateHalfDayCost')"
              @input="fieldValueChanged('rateHalfDayCost')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateHalfDay')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateHalfDay"
              v-model="obj.rateHalfDay"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateHalfDay')"
              data-cy="rateHalfDay"
              :rules="[
                form().decimalValid(this, 'rateHalfDay'),
                form().required(this, 'rateHalfDay')
              ]"
              :error-messages="form().serverErrors(this, 'rateHalfDay')"
              @input="fieldValueChanged('rateHalfDay')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateDayCost')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateDayCost"
              v-model="obj.rateDayCost"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateDayCost')"
              data-cy="rateDayCost"
              :rules="[
                form().decimalValid(this, 'rateDayCost'),
                form().required(this, 'rateDayCost')
              ]"
              :error-messages="form().serverErrors(this, 'rateDayCost')"
              @input="fieldValueChanged('rateDayCost')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateDay')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateDay"
              v-model="obj.rateDay"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateDay')"
              data-cy="rateDay"
              :rules="[
                form().decimalValid(this, 'rateDay'),
                form().required(this, 'rateDay')
              ]"
              :error-messages="form().serverErrors(this, 'rateDay')"
              @input="fieldValueChanged('rateDay')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateWeekCost')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateWeekCost"
              v-model="obj.rateWeekCost"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateWeekCost')"
              data-cy="rateWeekCost"
              :rules="[
                form().decimalValid(this, 'rateWeekCost'),
                form().required(this, 'rateWeekCost')
              ]"
              :error-messages="form().serverErrors(this, 'rateWeekCost')"
              @input="fieldValueChanged('rateWeekCost')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateWeek')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateWeek"
              v-model="obj.rateWeek"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateWeek')"
              data-cy="rateWeek"
              :rules="[
                form().decimalValid(this, 'rateWeek'),
                form().required(this, 'rateWeek')
              ]"
              :error-messages="form().serverErrors(this, 'rateWeek')"
              @input="fieldValueChanged('rateWeek')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateMonthCost')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateMonthCost"
              v-model="obj.rateMonthCost"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateMonthCost')"
              data-cy="rateMonthCost"
              :rules="[
                form().decimalValid(this, 'rateMonthCost'),
                form().required(this, 'rateMonthCost')
              ]"
              :error-messages="form().serverErrors(this, 'rateMonthCost')"
              @input="fieldValueChanged('rateMonthCost')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateMonth')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateMonth"
              v-model="obj.rateMonth"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateMonth')"
              data-cy="rateMonth"
              :rules="[
                form().decimalValid(this, 'rateMonth'),
                form().required(this, 'rateMonth')
              ]"
              :error-messages="form().serverErrors(this, 'rateMonth')"
              @input="fieldValueChanged('rateMonth')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateYearCost')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateYearCost"
              v-model="obj.rateYearCost"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateYearCost')"
              data-cy="rateYearCost"
              :rules="[
                form().decimalValid(this, 'rateYearCost'),
                form().required(this, 'rateYearCost')
              ]"
              :error-messages="form().serverErrors(this, 'rateYearCost')"
              @input="fieldValueChanged('rateYearCost')"
            ></gz-currency>
          </v-col>

          <v-col
            v-if="form().showMe(this, 'RateYear')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-currency
              ref="rateYear"
              v-model="obj.rateYear"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitRateYear')"
              data-cy="rateYear"
              :rules="[
                form().decimalValid(this, 'rateYear'),
                form().required(this, 'rateYear')
              ]"
              :error-messages="form().serverErrors(this, 'rateYear')"
              @input="fieldValueChanged('rateYear')"
            ></gz-currency>
          </v-col>

          <!-- <v-col
            v-if="form().showMe(this, 'DefaultRate')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <v-select
              ref="defaultRate"
              v-model="obj.defaultRate"
              :items="selectLists.loanunitrateunit"
              item-text="name"
              item-value="id"
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitDefaultRate')"
              data-cy="defaultRate"
              :rules="[form().integerValid(this, 'defaultRate')]"
              :error-messages="form().serverErrors(this, 'defaultRate')"
              @input="fieldValueChanged('defaultRate')"
            ></v-select>
          </v-col> -->

          <v-col
            v-if="form().showMe(this, 'UnitId')"
            cols="12"
            sm="6"
            lg="4"
            xl="3"
          >
            <gz-pick-list
              ref="unitId"
              v-model="obj.unitId"
              :aya-type="ayaTypes().Unit"
              show-edit-icon
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitShadowUnit')"
              data-cy="unitId"
              :error-messages="form().serverErrors(this, 'unitId')"
              @input="fieldValueChanged('unitId')"
            ></gz-pick-list>
          </v-col>

          <v-col cols="12" sm="6" lg="4" xl="3">
            <v-checkbox
              ref="active"
              v-model="obj.active"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('Active')"
              data-cy="active"
              :error-messages="form().serverErrors(this, 'active')"
              @change="fieldValueChanged('active')"
            ></v-checkbox>
          </v-col>
          <!-- --------------------------------- -->
          <v-col v-if="form().showMe(this, 'Notes')" cols="12">
            <v-textarea
              ref="notes"
              v-model="obj.notes"
              dense
              :readonly="formState.readOnly"
              :label="$ay.t('LoanUnitNotes')"
              :error-messages="form().serverErrors(this, 'notes')"
              data-cy="notes"
              auto-grow
              @input="fieldValueChanged('notes')"
            ></v-textarea>
          </v-col>

          <v-col v-if="form().showMe(this, 'Tags')" cols="12">
            <gz-tag-picker
              ref="tags"
              v-model="obj.tags"
              :readonly="formState.readOnly"
              data-cy="tags"
              :error-messages="form().serverErrors(this, 'tags')"
              @input="fieldValueChanged('tags')"
            ></gz-tag-picker>
          </v-col>

          <v-col cols="12">
            <gz-custom-fields
              ref="customFields"
              v-model="obj.customFields"
              :form-key="formCustomTemplateKey"
              :readonly="formState.readOnly"
              :parent-v-m="this"
              data-cy="customFields"
              :error-messages="form().serverErrors(this, 'customFields')"
              @input="fieldValueChanged('customFields')"
            ></gz-custom-fields>
          </v-col>

          <v-col v-if="form().showMe(this, 'Wiki')" cols="12">
            <gz-wiki
              ref="wiki"
              v-model="obj.wiki"
              :aya-type="ayaType"
              :aya-id="obj.id"
              :readonly="formState.readOnly"
              @input="fieldValueChanged('wiki')"
            ></gz-wiki
          ></v-col>

          <v-col v-if="form().showMe(this, 'Attachments') && obj.id" cols="12">
            <gz-attachments
              :readonly="formState.readOnly"
              :aya-type="ayaType"
              :aya-id="obj.id"
            ></gz-attachments
          ></v-col>
        </v-row>
      </v-form>
    </div>
    <v-overlay :value="!formState.ready || formState.loading">
      <v-progress-circular indeterminate :size="64" />
    </v-overlay>
  </div>
</template>
<script>
const FORM_KEY = "loan-unit-edit";
const API_BASE_URL = "loan-unit/";
const FORM_CUSTOM_TEMPLATE_KEY = "LoanUnit";
export default {
  data() {
    return {
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      selectLists: {
        loanunitrateunit: []
      },
      obj: {
        id: 0,
        concurrency: 0,
        name: null,
        active: true,
        notes: null,
        wiki: null,
        customFields: "{}",
        tags: [],
        serial: null,
        workOrderItemLoanId: null,
        rateHour: 0,
        rateHalfDay: 0,
        rateDay: 0,
        rateWeek: 0,
        rateMonth: 0,
        rateYear: 0,
        rateHourCost: 0,
        rateHalfDayCost: 0,
        rateDayCost: 0,
        rateWeekCost: 0,
        rateMonthCost: 0,
        rateYearCost: 0,
        defaultRate: 1,
        unitId: null
      },
      formState: {
        ready: false,
        dirty: false,
        valid: true,
        readOnly: false,
        loading: true,
        errorBoxMessage: null,
        appError: null,
        serverError: {}
      },
      rights: window.$gz.role.defaultRightsObject(),
      ayaType: window.$gz.type.LoanUnit
    };
  },
  watch: {
    formState: {
      handler: function(val) {
        if (this.formState.loading) {
          return;
        }
        if (val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":save");
        } else {
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":save");
        }
        if (!val.dirty && val.valid && !val.readOnly) {
          window.$gz.eventBus.$emit(
            "menu-enable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-enable-item", FORM_KEY + ":new");
        } else {
          window.$gz.eventBus.$emit(
            "menu-disable-item",
            FORM_KEY + ":duplicate"
          );
          window.$gz.eventBus.$emit("menu-disable-item", FORM_KEY + ":new");
        }
      },
      deep: true
    }
  },
  async created() {
    const vm = this;
    try {
      await initForm(vm);
      vm.rights = window.$gz.role.getRights(window.$gz.type.LoanUnit);
      vm.formState.readOnly = !vm.rights.change;
      window.$gz.eventBus.$on("menu-click", clickHandler);
      let setDirty = false;
      //id 0 means create or duplicate to new
      if (vm.$route.params.recordid != 0) {
        //is there already an obj from a prior operation?
        if (this.$route.params.obj) {
          //yes, no need to fetch it
          this.obj = this.$route.params.obj;
        } else {
          await vm.getDataFromApi(vm.$route.params.recordid);
        }
      } else {
        //Might be a duplicate and contain another record
        if (this.$route.params.obj) {
          this.obj = this.$route.params.obj;
          this.obj.concurrency = undefined;
          this.obj.id = 0;
          this.obj.name = `${this.obj.name} - ${window.$gz.translation.get(
            "Copy"
          )}`;
          setDirty = true;
        }
      }

      window.$gz.form.setFormState({
        vm: vm,
        loading: false,
        dirty: setDirty,
        valid: true
      });

      generateMenu(vm);
    } catch (error) {
      window.$gz.errorHandler.handleFormError(error, vm);
    } finally {
      vm.formState.ready = true;
    }
  },
  async beforeRouteLeave(to, from, next) {
    if (!this.formState.dirty || JUST_DELETED) {
      next();
      return;
    }
    if ((await window.$gz.dialog.confirmLeaveUnsaved()) === true) {
      next();
    } else {
      next(false);
    }
  },
  beforeDestroy() {
    window.$gz.eventBus.$off("menu-click", clickHandler);
  },
  methods: {
    canSave: function() {
      return this.formState.valid && this.formState.dirty;
    },
    canDuplicate: function() {
      return this.formState.valid && !this.formState.dirty;
    },
    ayaTypes: function() {
      return window.$gz.type;
    },
    form() {
      return window.$gz.form;
    },
    fieldValueChanged(ref) {
      if (
        this.formState.ready &&
        !this.formState.loading &&
        !this.formState.readOnly
      ) {
        window.$gz.form.fieldValueChanged(this, ref);
      }
    },
    async getDataFromApi(recordId) {
      const vm = this;
      window.$gz.form.setFormState({
        vm: vm,
        loading: true
      });
      if (!recordId) {
        throw new Error(FORM_KEY + "::getDataFromApi -> Missing recordID!");
      }
      try {
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.get(API_BASE_URL + recordId);
        if (res.error) {
          if (res.error.code == "2010") {
            window.$gz.form.handleObjectNotFound(vm);
          }
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          vm.obj = res.data;
          generateMenu(vm);
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true,
            loading: false
          });
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async submit() {
      const vm = this;
      if (vm.canSave == false) {
        return;
      }
      try {
        window.$gz.form.setFormState({
          vm: vm,
          loading: true
        });
        window.$gz.form.deleteAllErrorBoxErrors(vm);
        const res = await window.$gz.api.upsert(API_BASE_URL, vm.obj);
        if (res.error) {
          vm.formState.serverError = res.error;
          window.$gz.form.setErrorBoxErrors(vm);
        } else {
          if (res.data.id) {
            //POST
            vm.obj = res.data;
            this.$router.replace({
              name: "loan-unit-edit",
              params: {
                recordid: res.data.id,
                obj: res.data
              }
            });
          } else {
            //PUT
            vm.obj.concurrency = res.data.concurrency;
          }
          window.$gz.form.setFormState({
            vm: vm,
            dirty: false,
            valid: true
          });
        }
      } catch (ex) {
        window.$gz.errorHandler.handleFormError(ex, vm);
      } finally {
        window.$gz.form.setFormState({
          vm: vm,
          loading: false
        });
      }
    },
    async remove() {
      try {
        const dialogResult = await window.$gz.dialog.confirmDelete();
        if (dialogResult != true) {
          return;
        }
        window.$gz.form.setFormState({
          vm: this,
          loading: true
        });
        if (this.$route.params.recordid == 0) {
          JUST_DELETED = true;
          this.$router.go(-1);
        } else {
          window.$gz.form.deleteAllErrorBoxErrors(this);
          const res = await window.$gz.api.remove(
            API_BASE_URL + this.$route.params.recordid
          );
          if (res.error) {
            this.formState.serverError = res.error;
            window.$gz.form.setErrorBoxErrors(this);
          } else {
            JUST_DELETED = true;
            this.$router.go(-1);
          }
        }
      } catch (error) {
        window.$gz.errorHandler.handleFormError(error, this);
      } finally {
        window.$gz.form.setFormState({
          vm: this,
          loading: false
        });
      }
    },
    duplicate() {
      this.$router.push({
        name: "loan-unit-edit",
        params: {
          recordid: 0,
          obj: this.obj
        }
      });
    }
  }
};

/////////////////////////////
//
//
async function clickHandler(menuItem) {
  if (!menuItem) {
    return;
  }
  const m = window.$gz.menu.parseMenuItem(menuItem);
  if (m.owner == FORM_KEY && !m.disabled) {
    switch (m.key) {
      case "save":
        m.vm.submit();
        break;
      case "delete":
        m.vm.remove();
        break;
      case "new":
        m.vm.$router.push({
          name: "loan-unit-edit",
          params: { recordid: 0 }
        });
        break;
      case "duplicate":
        m.vm.duplicate();
        break;
      case "report":
        {
          const res = await m.vm.$refs.reportSelector.open(
            {
              AType: window.$gz.type.LoanUnit,
              selectedRowIds: [m.vm.obj.id]
            },
            m.id
          );
          if (res == null) {
            return;
          }
          window.$gz.form.setLastReportMenuItem(FORM_KEY, res, m.vm);
        }
        break;
      case "WorkOrderList":
        m.vm.$router.push({
          name: "svc-workorder-item-loans",
          params: {
            aType: m.vm.ayaType,
            objectId: m.vm.obj.id,
            name: m.vm.obj.name
          }
        });
        break;
      case "QuoteList":
        m.vm.$router.push({
          name: "svc-quote-item-units",
          params: {
            aType: m.vm.ayaType,
            objectId: m.vm.obj.id,
            name: m.vm.obj.name
          }
        });
        break;
      case "PMList":
        m.vm.$router.push({
          name: "svc-pm-item-units",
          params: {
            aType: m.vm.ayaType,
            objectId: m.vm.obj.id,
            name: m.vm.obj.name
          }
        });
        break;
      default:
        window.$gz.eventBus.$emit(
          "notify-warning",
          FORM_KEY + "::context click: [" + m.key + "]"
        );
    }
  }
}

//////////////////////
//
//
function generateMenu(vm) {
  const menuOptions = {
    isMain: false,
    readOnly: vm.formState.readOnly,
    icon: "$ayiPlug",
    title: "LoanUnit",
    helpUrl: "svc-loaners",
    formData: {
      ayaType: window.$gz.type.LoanUnit,
      recordId: vm.$route.params.recordid,
      formCustomTemplateKey: FORM_CUSTOM_TEMPLATE_KEY,
      recordName: vm.obj.name
    },
    menuItems: []
  };

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "Save",
      icon: "$ayiSave",
      surface: true,
      key: FORM_KEY + ":save",
      vm: vm
    });
  }

  menuOptions.menuItems.push({
    title: "Report",
    icon: "$ayiFileAlt",
    key: FORM_KEY + ":report",
    vm: vm
  });

  const lastReport = window.$gz.form.getLastReport(FORM_KEY);
  if (lastReport != null) {
    menuOptions.menuItems.push({
      title: lastReport.name,
      notrans: true,
      icon: "$ayiFileAlt",
      key: FORM_KEY + ":report:" + lastReport.id,
      vm: vm
    });
  }

  if (vm.rights.change) {
    menuOptions.menuItems.push({
      title: "New",
      icon: "$ayiPlus",
      key: FORM_KEY + ":new",
      vm: vm
    });
  }

  if (vm.rights.change && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Duplicate",
      icon: "$ayiClone",
      key: FORM_KEY + ":duplicate",
      vm: vm
    });
  }

  if (vm.rights.delete && vm.$route.params.recordid != 0) {
    menuOptions.menuItems.push({
      title: "Delete",
      icon: "$ayiTrashAlt",
      surface: false,
      key: FORM_KEY + ":delete",
      vm: vm
    });
  }

  menuOptions.menuItems.push({ divider: true, inset: false });

  menuOptions.menuItems.push({
    title: "WorkOrderList",
    icon: "$ayiTools",
    key: FORM_KEY + ":WorkOrderList",
    vm: vm
  });

  menuOptions.menuItems.push({
    title: "QuoteList",
    icon: "$ayiPencilAlt",
    key: FORM_KEY + ":QuoteList",
    vm: vm
  });

  menuOptions.menuItems.push({
    title: "PMList",
    icon: "$ayiBusinessTime",
    key: FORM_KEY + ":PMList",
    vm: vm
  });

  menuOptions.menuItems.push({ divider: true, inset: false });

  window.$gz.eventBus.$emit("menu-change", menuOptions);
}

let JUST_DELETED = false;

/////////////////////////////////
//
//
async function initForm(vm) {
  await fetchTranslatedText();
  await window.$gz.formCustomTemplate.get(FORM_CUSTOM_TEMPLATE_KEY, vm);
  await populateSelectionLists(vm);
}

//////////////////////////////////////////////////////////
//
// Ensures UI translated text is available
//
async function fetchTranslatedText() {
  await window.$gz.translation.cacheTranslations([
    "LoanUnit",
    "LoanUnitName",
    "LoanUnitNotes",
    "LoanUnitSerial",
    "LoanUnitCurrentWorkOrderItemLoan",
    "LoanUnitRateDay",
    "LoanUnitRateHalfDay",
    "LoanUnitRateHour",
    "LoanUnitRateMonth",
    "LoanUnitRateWeek",
    "LoanUnitRateYear",
    "LoanUnitRateDayCost",
    "LoanUnitRateHalfDayCost",
    "LoanUnitRateHourCost",
    "LoanUnitRateMonthCost",
    "LoanUnitRateWeekCost",
    "LoanUnitRateYearCost",
    //"LoanUnitDefaultRate",
    "LoanUnitShadowUnit",
    "LoanUnitCustom1",
    "LoanUnitCustom2",
    "LoanUnitCustom3",
    "LoanUnitCustom4",
    "LoanUnitCustom5",
    "LoanUnitCustom6",
    "LoanUnitCustom7",
    "LoanUnitCustom8",
    "LoanUnitCustom9",
    "LoanUnitCustom10",
    "LoanUnitCustom11",
    "LoanUnitCustom12",
    "LoanUnitCustom13",
    "LoanUnitCustom14",
    "LoanUnitCustom15",
    "LoanUnitCustom16"
  ]);
}

//////////////////////
//
//
async function populateSelectionLists(vm) {
  await window.$gz.enums.fetchEnumList("loanunitrateunit");
  vm.selectLists.loanunitrateunit = window.$gz.enums.getSelectionList(
    "loanunitrateunit"
  );
}
</script>
